function getDiscussionBodyElement() {
    return document.querySelector('#discussion_body');
}

function appendDiscussionBodyText(body) {
    var element = getDiscussionBodyElement();
    element.value = element.value + body;
}

function getDiscussionBodyText() {
    return getDiscussionBodyElement().value;
}

function getFirstVisibleNode(nodes) {
    for (var i = 0, node; node = nodes[i]; i++) {
        if (node.offsetHeight) return node;
    }
    return null;
}

function getNextAvailableFileInputButton() {
    return getFirstVisibleNode(document.querySelectorAll("input[type='file']"));
}

function getNextAvailableFileInputButtonPosition() {
    var button = getNextAvailableFileInputButton();
    if (!button) {
        return null;
    }
    return getAbsolutePosition(button);
}

function getAbsolutePosition(element) {
    var res = new Object();
    res.x = 0;
    res.y = 0;
    if (element !== null) {
        res.x = element.offsetLeft;
        res.y = element.offsetTop;

        var offsetParent = element.offsetParent;
        var parentNode = element.parentNode;

        while (offsetParent !== null) {
            res.x += offsetParent.offsetLeft;
            res.y += offsetParent.offsetTop;

            if (offsetParent != document.body && offsetParent != document.documentElement) {
                res.x -= offsetParent.scrollLeft;
                res.y -= offsetParent.scrollTop;
            }
            parentNode = offsetParent.parentNode;
            offsetParent = offsetParent.offsetParent;
        }
    }
    return res;
}
