
jQuery.fn.highlight = function(queryString) {  

	function innerHighlight(node, expression) {
		if (node.nodeType == 3) {
			var matchObject = expression.exec(node.data);
			if (matchObject) {
				var spannode = document.createElement('span');
				spannode.className = 'rphighlight';
				var middlebit = node.splitText(matchObject.index);
				var endbit = middlebit.splitText(matchObject[0].length);
				var middleclone = middlebit.cloneNode(true);
				spannode.appendChild(middleclone);
				middlebit.parentNode.replaceChild(spannode, middlebit);
				return 1;
			}
		}
		else if (node.nodeType == 1 && node.childNodes && !/(script|style)/i.test(node.tagName)) {
			for (var i = 0; i < node.childNodes.length; i++) {
				i += innerHighlight(node.childNodes[i], expression);
			}
		}
		return 0;
	}

	var words = queryString.split(" "); 
	var expression = "";

	for (var i = 0; i < words.length; i++) {
		var word = words[i];
		if (word[0] == "-") {
			continue;
		}
		if (word[0] == "+") {
			word = word.substring(1);
		}
		word = word.replace(/\s+/g, "");
		if (word != "") {
			word = word.replace(/[*]/g, "\\w*");
			expression = expression + "\\b" + word + "\\b|";
		}
	}
	if (expression == "") {
		return null;
	}
	expression = new RegExp("(" + expression.substring(0, expression.length - 1) + ")", "i");

	return this.each(function() {
		innerHighlight(this, expression);
	});
};

jQuery.fn.removeHighlight = function() {
	return this.find("span.rphighlight").each(function() {
		this.parentNode.firstChild.nodeName;
		with(this.parentNode) {
			replaceChild(this.firstChild, this);
			normalize();
		}
	}).end();
};
